package yrpg.bamp.basedata.webapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import dm.jdbc.util.StringUtil;
import kd.bos.bd.log.enums.BDCtrlOperateSource;
import kd.bos.bd.log.helper.BDCtrlLogHelper;
import kd.bos.bd.service.AssignService;
import kd.bos.bd.service.BaseDataCustomService;
import kd.bos.bd.service.TreeBaseDataCommonService;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.basedata.BaseDataResponse;
import kd.bos.form.control.TreeView;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.exception.KDBizException;
import kd.bos.form.ConfirmCallBackListener;
import kd.bos.form.ConfirmTypes;
import kd.bos.form.MessageBoxOptions;
import kd.bos.form.control.TreeView;
import kd.bos.form.plugin.bdctrl.validator.TreeBaseDataAssignPreValidator;
import kd.bos.openapi.api.result.*;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiParam;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.openapi.common.result.OpenApiResult;
import kd.bos.openapi.common.util.OpenApiSdkUtil;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.orm.util.CollectionUtils;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.fi.dcm.common.util.StringUtils;
import yrpg.bamp.basedata.common.ApiReqModel;
import yrpg.bamp.basedata.common.AssembleResponseUtil;

import javax.validation.Valid;
import java.util.*;

@ApiController(value="CommonBill",desc="统一url入口")
public class SupplierApiController {
	//存放实际地址和接口入口的
	@ApiPostMapping(value="supplierURLApiHandler")
	public CustomApiResult<Object> supplierApiHandler(@Valid  @ApiParam("入口参数") ApiReqModel reqModel) {
		//获取入参
		String reqdata=reqModel.getData();
		JSONArray dataArray = JSONObject.parseArray(reqdata);
		if(dataArray.size()>200){
			throw new KDBizException("单次同步的供应商数据过多");
		}
		// 新增（修改）、启用（解封）、禁用（封存） 入参
		JSONObject saveDataJson = new JSONObject();
		JSONObject freezeDataJson = new JSONObject();
		JSONObject unfreezeDataJson = new JSONObject();
		//解封时更新
		JSONObject unfreezeUpdateDataJson = new JSONObject();

		// 新增（修改）、启用（解封）、禁用（封存） data层参数
		JSONArray supplierData = new JSONArray();
		JSONArray freezeNums = new JSONArray();
		JSONArray unfreezeNums = new JSONArray();
		//解封时更新
		JSONArray unfreezeData = new JSONArray();

		JSONObject freezeNumsJson = new JSONObject();
		JSONObject unfreezeNumsJson = new JSONObject();

		List<String> mainids = new ArrayList<String>();
		for(int i=0;i<dataArray.size();i++) {
			JSONObject jsonObject = dataArray.getJSONObject(i);
			String number = jsonObject.getString("yrpg_mainid");
			mainids.add(number);
		}
		QFilter filter = new QFilter("yrpg_mainid", QCP.in,mainids);
		//获取系统现有供应商数据
		DynamicObjectCollection suppliers = QueryServiceHelper.query("bd_supplier", "number,yrpg_mainid,enable", new QFilter[]{filter});
		Map<String,String> supplierStatusMap = new HashMap<String,String>();
		Map<String,String> supplierNumMap = new HashMap<String,String>();
		for (DynamicObject supplier : suppliers){
			supplierStatusMap.put(supplier.getString("yrpg_mainid"),supplier.getString("enable"));
			supplierNumMap.put(supplier.getString("number"),supplier.getString("yrpg_mainid"));
		}
		//新增废弃数据，执行跳过，接口返回参数
		JSONArray newfreezeData = new JSONArray();

		//循环判断部门进入保存、封存、解封集合
		for(int i=0;i<dataArray.size();i++){
			JSONObject jsonObject = dataArray.getJSONObject(i);
			String number = jsonObject.getString("yrpg_mainid");
			boolean isfreeze = jsonObject.getBoolean("isfreeze");
			//根据入参是否封存，已经系统中状态判断
			if(supplierStatusMap.get(number)==null&&isfreeze){
				newfreezeData.add(jsonObject);
				//禁用直接跳过
				continue;
			}
			//根据入参是否封存，已经系统中状态判断
			if(supplierStatusMap.get(number)==null){
				//新增
				supplierData.add(jsonObject);
			}else if(!isfreeze&&supplierStatusMap.get(number).equals("1")){
				//更新
				supplierData.add(jsonObject);
			}else if(supplierStatusMap.get(number).equals("1")&&isfreeze){
				//禁用
				freezeNums.add(number);
			}else if(supplierStatusMap.get(number).equals("0")&&!isfreeze){
				//启用更新
				unfreezeNums.add(number);
				unfreezeData.add(jsonObject);

			}
		}

		//返回值
		BaseFilterResult responseData = new BaseFilterResult();
		CustomApiResult finalResult =new CustomApiResult();
		//判断是否调用禁用启用
		boolean isfreeze = false;
		JSONObject resultJson = new JSONObject();
		List<JSONObject> resultList=new ArrayList<>();
		JSONObject jsonResult=null;
		int falseNum = 0;
		int successNum = 0;
		//调用禁用接口
		if(freezeNums.size()>0){
			isfreeze = true;
			freezeNumsJson.put("yrpg_mainids",freezeNums);
			freezeDataJson.put("data",freezeNumsJson);
			//调用接口
			OpenApiResult adminfreeze = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bd_supplier/supplierDisable", freezeDataJson, new HashMap<>());
			BaseFilterResult data = (BaseFilterResult)adminfreeze.getData();
			List<BaseFilterItemData> result = data.getResult();
			jsonResult=new JSONObject();
			falseNum = 0;
			successNum = 0;
			for(BaseFilterItemData item : result){
				/*String number = item.getNumber();
				if(!StringUtils.isEmpty(number)){
					item.setNumber(supplierNumMap.get(number));
				}*/
				jsonResult.put("id",item.getId());
				jsonResult.put("mdm_code",item.getNumber());
				jsonResult.put("success",item.getErrors().size()==0?true:false);
				if(item.getErrors().size()!=0){
					String errorList = StringUtils.join(item.getErrors(),",");
					jsonResult.put("errorInfo",errorList);
					falseNum = falseNum + 1;
				}else{
					successNum = successNum + 1;
				}
				resultList.add(jsonResult);
			}
			//responseData = data;
		}
		//调用解封接口
		if(unfreezeNums.size()>0){
			unfreezeNumsJson.put("yrpg_mainids",unfreezeNums);
			unfreezeDataJson.put("data",unfreezeNumsJson);
			//调用接口
			OpenApiResult unfreezeResult = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bd_supplier/supplierEnable", unfreezeDataJson, new HashMap<>());
			unfreezeUpdateDataJson.put("data",unfreezeData);
			//调用接口
			OpenApiResult adminsave = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bd_supplier/suppliersave", unfreezeUpdateDataJson, new HashMap<>());
			ApiSaveResult data = (ApiSaveResult)adminsave.getData();
			//根据保存更新操作返回值结构，将保存返回值组装
			//AssembleResponseUtil.assembleResult(data,responseData,isfreeze);
			List<ApiSaveItemData> result = data.getResult();
			jsonResult=new JSONObject();
			falseNum = 0;
			successNum = 0;
			for(ApiSaveItemData item : result){
				/*String number = item.getNumber();
				if(!StringUtils.isEmpty(number)){
					item.setNumber(supplierNumMap.get(number));
				}*/
				jsonResult.put("id",item.getId());
				jsonResult.put("mdm_code",item.getNumber());
				jsonResult.put("success",item.getErrors().size()==0?true:false);
				if(item.getErrors().size()!=0){
					String errorList = "";
					for(ApiSaveRowErrorData temp : item.getErrors()){
						errorList += StringUtils.join(temp.getRowMsg(),",");

					}
					jsonResult.put("errorInfo",errorList);
					falseNum = falseNum + 1;
				}else{
					successNum = successNum + 1;
				}
				resultList.add(jsonResult);
			}


		}
		//调用保存接口
		if(supplierData.size()>0){


			saveDataJson.put("data",supplierData);
			//调用接口
			OpenApiResult adminsave = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bd_supplier/suppliersave", saveDataJson, new HashMap<>());
			ApiSaveResult data = (ApiSaveResult)adminsave.getData();
			//根据保存更新操作返回值结构，将保存返回值组装
			//AssembleResponseUtil.assembleResult(data,responseData,isfreeze);
			List<ApiSaveItemData> result = data.getResult();
			jsonResult=new JSONObject();
			falseNum = 0;
			successNum = 0;
			for(ApiSaveItemData item : result){
				/*String number = item.getNumber();
				if(!StringUtils.isEmpty(number)){
					item.setNumber(supplierNumMap.get(number));
				}*/
				jsonResult.put("id",item.getId());
				jsonResult.put("mdm_code",item.getNumber());
				jsonResult.put("success",item.getErrors().size()==0?true:false);
				if(item.getErrors().size()!=0){
					String errorList = "";
					for(ApiSaveRowErrorData temp : item.getErrors()){
						errorList += StringUtils.join(temp.getRowMsg(),",");

					}
					jsonResult.put("errorInfo",errorList);
					falseNum = falseNum + 1;
				}else{
					successNum = successNum + 1;
				}
				resultList.add(jsonResult);
				//		//调用分配策略
		List<Long> dataIds = new ArrayList();
		dataIds.add(Long.parseLong(item.getId()));
        Set<Long> orgIds = new HashSet();


		for(int i=0;i<dataArray.size();i++){
			JSONObject dataObject=dataArray.getJSONObject(i);
			JSONArray supplierOrg = dataObject.getJSONArray("supplier_org");
			for(int j=0;j<supplierOrg.size();j++){
				orgIds.add(supplierOrg.getLong(j));
			}
		}
		String entity = "bd_supplier";
		String tempId = "1874622230558727168";
		Long useOrgId = Long.parseLong(tempId);
		List<Long> dataIdsTemp = new ArrayList(dataIds.size());
		dataIdsTemp.addAll(dataIds);
		String appId = "basedata";
		AssignService assignService = new AssignService(entity, false);
		BDCtrlLogHelper.setLogSourceType(BDCtrlOperateSource.INTERFACE_OP);
		BaseDataResponse response = assignService.assign(useOrgId, appId, new HashSet(dataIdsTemp), orgIds, false);
		if (response.isSuccess() == false) {
			throw new KDBizException("分配失败");
		}
			}
		}
		/*if(newfreezeData.size()>0){
			AssembleResponseUtil.addfreezeResult(newfreezeData,responseData);
		}*/
/*
		//多类型接口 过滤默认为空
		responseData.setFilter("");
		finalResult.setData(resultList);*/
		resultJson.put("data",resultList);
		resultJson.put("success",true);
		resultJson.put("message","本次主表装载成功" + successNum + " 条,失败 "+ falseNum + " 条");
		return CustomApiResult.success(resultJson);
	}

}